local mod_storage_load, mod_storage_save = mod_storage_load, mod_storage_save

introTimer = 0
gMmxStates = {}
enable_sounds = true
for i = 0, (MAX_PLAYERS - 1) do
    gMmxStates[i] = {}
    local mmx = gMmxStates[i]
    local s = gPlayerSyncTable[i]
    local m = gMarioStates[i]

    -- Char/Moveset enabled
    s.character = 'x'
    s.enable_voice = true
    s.enable_model = true
    s.enable_color = true
    s.menu_open = false

     -- Colors related
     s.colorR = {}
     s.colorG = {}
     s.colorB = {}
     for j = 0, PLAYER_PART_MAX do
         s.colorR[j] = 0
         s.colorG[j] = 0
         s.colorB[j] = 0
     end

    -- Smooth continuity related
    mmx.prevPos = {x = 0, y = 0, z = 0}
    mmx.dPrevPos = {x = 0, y = 0, z = 0}

    -- Landing related
    s.land_timer = 0

    -- Wallkick related variables
    mmx.lastWallKickPos = {x = 0, z = 0} -- Y is not needed
    mmx.previousWallYawRads = 0
    s.quasiSameSideWallKicks = 0
    s.just_walljumped = 0
    s.initialFaceAngleAfterWallKick = 0
    s.firstWallKick = true

    -- Vanilla actions
    mmx.execute_groundpound = false
    mmx.execute_punch = false
    s.execute_walking = false

    -- X related variables
    s.x_armor = 0
    s.x_shooting = 0
    s.x_glow_index = 0
    s.x_charge_level = 0
    s.x_charge_timer = 0
    s.x_charge_spawned = 0
    s.x_max_charge_looped = 0
    mmx.x_charge_sound_stopped = true

    -- Vile related variables
    s.vile_shooting = 0
    s.vile_meter = 10

    -- Characters with dashes
    s.ground_dash_cooldown = 0
    s.jump_dash_state = false
    s.already_airdashed = false
    s.jumped_from_ground_dash = false
end

djui_popup_create("Press D-PAD UP or write /mmx to open the \\#0D3CC0\\Mega Man X \\#ffffff\\menu.", 3)

function initStorage()
    local s0 = gPlayerSyncTable[gMarioStates[0].playerIndex]
    if (mod_storage_load('MmxChar')) then
        s0.character = mod_storage_load('MmxChar')
    else
        s0.character = 'x' -- Possible values: x, vile, none
        mod_storage_save('MmxChar', 'x')
    end
    if (mod_storage_load('MmxColor')) then
        if mod_storage_load('MmxColor') == 'true' then
            s0.enable_color = true
        else
            s0.enable_color = false
        end
    else
        s0.enable_color = true -- Possible values: x, vile, none
        mod_storage_save('MmxColor', 'true')
    end
    if (mod_storage_load('MmxArmor')) then
        s0.x_armor = tonumber(mod_storage_load('MmxArmor'))
    else
        s0.x_armor = 0 -- 0: No armor, 1: First Armor
        mod_storage_save('MmxArmor', '0')
    end
end

--initStorage()

function active_player(m)
    local np = gNetworkPlayers[m.playerIndex]
    if m.playerIndex == 0 then
        return true
    end
    if not np.connected then
        return false
    end
    if np.currCourseNum ~= gNetworkPlayers[0].currCourseNum then
        return false
    end
    if np.currActNum ~= gNetworkPlayers[0].currActNum then
        return false
    end
    if np.currLevelNum ~= gNetworkPlayers[0].currLevelNum then
        return false
    end
    if np.currAreaIndex ~= gNetworkPlayers[0].currAreaIndex then
        return false
    end
    return is_player_active(m)
end

function mmx_play_sound(sound, mPos, intensity)
    if enable_sounds then
        audio_sample_play(sound, mPos, intensity)
    end
end