-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local math_sin, math_cos, sins, coss, network_player_from_global_index, obj_mark_for_deletion, obj_spawn_loot_yellow_coins, mmx_play_sound,
 nearest_mario_state_to_object, obj_get_nearest_object_with_behavior_id, obj_check_hitbox_overlap, cur_obj_scale, obj_scale, network_send_object =
 math.sin, math.cos, sins, coss, network_player_from_global_index, obj_mark_for_deletion, obj_spawn_loot_yellow_coins, mmx_play_sound,
  nearest_mario_state_to_object, obj_get_nearest_object_with_behavior_id, obj_check_hitbox_overlap, cur_obj_scale, obj_scale, network_send_object

-----------------------------------------------------------------
-----------------------------------------------------------------
----- INTERACTIONS ----------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

--------
--NPCs--
--------

function leg_bomb_interact_bobomb_buddy(o, explosionPos)
    spawn_non_sync_object(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, nil)
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

function leg_bomb_interact_general_npc(o, explosionPos)
    spawn_mist_particles()
    play_sound(SOUND_OBJ_DEFAULT_DEATH, o.header.gfx.cameraToObject)
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

function leg_bomb_interact_mips(o, explosionPos)
    bhv_spawn_star_no_level_exit(o, o.oBehParams2ndByte + 3, true)
    spawn_mist_particles()
    play_sound(SOUND_OBJ_SWOOP_DEATH, o.header.gfx.cameraToObject)
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

function leg_bomb_interact_ukiki_cage(o, explosionPos)
    if (o.oAction == UKIKI_CAGE_ACT_WAIT_FOR_UKIKI) then
        o.oAction = UKIKI_CAGE_ACT_FALL
        --network_send_object(o, false)
    end
end

-------------------
--GENERAL ENEMIES--
-------------------

function leg_bomb_interact_chuckya(o, explosionPos)
    o.usingObj = nil
    obj_mark_for_deletion(o)
    obj_spawn_loot_yellow_coins(o, 5, 20.0)
    spawn_mist_particles_with_sound(SOUND_OBJ_CHUCKYA_DEATH)
    --network_send_object(o, false)
end

function leg_bomb_interact_enemygeneral(o, explosionPos)
    if o.oInteractStatus ~= ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED then
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
    end
end

-----------------------
--BOB-OMB BATTLEFIELD--
-----------------------

function leg_bomb_interact_goomba(o, explosionPos)
    spawn_mist_particles()
    if (o.oGoombaSize == GOOMBA_SIZE_HUGE) then
        spawn_non_sync_object(id_bhvMrIBlueCoin, E_MODEL_BLUE_COIN, o.oPosX, o.oPosY, o.oPosZ, nil)
        play_sound(SOUND_OBJ_ENEMY_DEATH_LOW, o.header.gfx.cameraToObject)
    else
        o.oNumLootCoins = 1
        obj_spawn_loot_yellow_coins(o, 1, 20.0)
        play_sound(SOUND_OBJ_ENEMY_DEATH_HIGH, o.header.gfx.cameraToObject)
    end
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

function leg_bomb_interact_koopa(o, explosionPos)
    if (o.oKoopaMovementType == KOOPA_BP_NORMAL or o.oKoopaMovementType == KOOPA_BP_UNSHELLED) then
        spawn_non_sync_object(id_bhvMrIBlueCoin, E_MODEL_BLUE_COIN, o.oPosX, o.oPosY, o.oPosZ, nil)
    end
    if (o.oKoopaMovementType ~= KOOPA_BP_UNSHELLED and o.oBehParams2ndByte ~= KOOPA_BP_TINY) then
        spawn_non_sync_object(id_bhvKoopaShell, E_MODEL_KOOPA_SHELL, o.oPosX, o.oPosY, o.oPosZ, nil)
    end
    spawn_mist_particles_with_sound(SOUND_OBJ_KOOPA_DAMAGE)
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

function leg_bomb_interact_bobomb(o, explosionPos)
    if  o.oAction ~= BOBOMB_ACT_EXPLODE then
        o.oAction = BOBOMB_ACT_EXPLODE
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_chainchomp(o, explosionPos)
    o.oSubAction = CHAIN_CHOMP_SUB_ACT_LUNGE
    o.oChainChompMaxDistFromPivotPerChainPart = 900.0 / 5
    o.oForwardVel = 0.0
    o.oVelY = 300.0
    o.oGravity = -4.0
    o.oChainChompTargetPitch = -0x3000
    --network_send_object(o, false)
end

function leg_bomb_interact_waterbomb(o, explosionPos)
    if o.oAction ~= WATER_BOMB_ACT_EXPLODE then
        o.oAction = WATER_BOMB_ACT_EXPLODE
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_kingbobomb(o, explosionPos)
    if (o.oFlags & OBJ_FLAG_HOLDABLE) ~= 0 and o.oAction ~= 8 then
        local angle = atan2s(o.oPosZ - explosionPos.z, o.oPosX - explosionPos.x)
        o.oVelY = 30
        o.oForwardVel = 30
        o.oMoveFlags = 0
        o.oMoveAngleYaw = angle
        o.oAction = 4
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_breakablebox(o, explosionPos)
    if o.oInteractStatus ~=  ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED then
        o.oInteractStatus =  ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_breakableboxsmall(o, explosionPos)
    if o.oInteractStatus ~= ATTACK_KICK_OR_TRIP | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING then
        o.oInteractStatus = ATTACK_KICK_OR_TRIP | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
        --network_send_object(o, false)
    end
end

--------------------
--WHOMP'S FORTRESS--
--------------------

function leg_bomb_interact_bridge(o, explosionPos)
    if (o.oFaceAnglePitch > -0x4000) then
        o.oAction = 2
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_whomp(o, explosionPos)
    if o.oAction ~= 8 then
        o.oNumLootCoins = 5
        obj_spawn_loot_yellow_coins(o, 5, 20.0)
        o.oAction = 8
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_whompking(o, explosionPos)
    if o.oAction ~= 8 and o.oAction ~= 0 then
        o.oHealth = o.oHealth - 1
        play_sound(SOUND_OBJ2_WHOMP_SOUND_SHORT, o.header.gfx.cameraToObject)
        play_sound(SOUND_OBJ_KING_WHOMP_DEATH, o.header.gfx.cameraToObject)
        if (o.oHealth == 0) then
            o.oAction = 8
        end
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_piranhaplant(o, explosionPos)
    if o.oAction ~= PIRANHA_PLANT_ACT_SHRINK_AND_DIE 
    and o.oAction ~= PIRANHA_PLANT_ACT_ATTACKED and o.oAction ~= PIRANHA_PLANT_ACT_WAIT_TO_RESPAWN then
        stop_secondary_music(50)
        o.oAction = PIRANHA_PLANT_ACT_ATTACKED
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_bulletbill(o, explosionPos)
    if o.oAction ~= 3 and o.oAction ~= 0 then
        o.oAction = 3
        spawn_non_sync_object(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, nil)
        --network_send_object(o, false)
    end
end

----------------------
--COOL COOL MOUNTAIN--
----------------------

function leg_bomb_interact_mrblizzard(o, explosionPos)
    spawn_mist_particles_with_sound(SOUND_OBJ_DEFAULT_DEATH)
    o.oNumLootCoins = 3
    obj_spawn_loot_yellow_coins(o, 3, 20.0);
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

----------------------
--BIG BOO's HUNT------
----------------------

function leg_bomb_interact_madpiano(o, explosionPos)
    spawn_mist_particles_with_sound(SOUND_GENERAL_WALL_EXPLOSION)
    spawn_triangle_break_particles(20, 138, 3, 4);
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

----------------------
--SHIFTING SAND LAND--
----------------------
function leg_bomb_interact_klepto(o, explosionPos)
    if o.oInteractStatus ~= ATTACK_FROM_ABOVE | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING then
        o.oInteractStatus = ATTACK_FROM_ABOVE | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
        --network_send_object(o, false)
    end
end

function leg_bomb_interact_jumping_box(o, explosionPos)
    if o.oInteractStatus ~= INT_STATUS_STOP_RIDING then
        o.oInteractStatus = INT_STATUS_STOP_RIDING
    end
end

--------------------
--LETHAL LAVA LAND--
--------------------
function leg_bomb_interact_mri(o, explosionPos)
    if (o.oBehParams2ndByte ~= 0) then
        if (o.oAction ~= 3) then
            o.oAction = 3
            o.oTimer = 104
        end
    else
        spawn_mist_particles_with_sound(SOUND_OBJ_DEFAULT_DEATH)
        spawn_non_sync_object(id_bhvMrIBlueCoin, E_MODEL_BLUE_COIN, o.oPosX, o.oPosY, o.oPosZ, nil)
        obj_mark_for_deletion(o)
    end
    --network_send_object(o, false)
end

function leg_bomb_interact_bully(o, explosionPos)
    local angle = atan2s(o.oPosZ - explosionPos.z, o.oPosX - explosionPos.x)
    o.oMoveAngleYaw = angle
    if o.oInteractStatus ~= ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    and o.oAction ~= BULLY_ACT_LAVA_DEATH and o.oAction ~= BULLY_ACT_DEATH_PLANE_DEATH then
        o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        o.oForwardVel = 50
        --network_send_object(o, false)
    end
end

---------------------
---TINY HUGE ISLAND--
---------------------

function leg_bomb_interact_spiny(o, explosionPos)
    spawn_mist_particles()
    play_sound(SOUND_OBJ_DEFAULT_DEATH, o.header.gfx.cameraToObject)
    o.oNumLootCoins = 1
    obj_spawn_loot_yellow_coins(o, 1, 20.0);
    obj_mark_for_deletion(o)
    --network_send_object(o, false)
end

function leg_bomb_interact_firepiranhaplant(o, explosionPos)
    if o.oAction ~= FIRE_PIRANHA_PLANT_ACT_HIDE then
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
    end
end

------------------------
---TALL TALL MOUNTAIN---
------------------------

function leg_bomb_interact_monty_mole(o, explosionPos)
    if o.oAction ~= MONTY_MOLE_ACT_SELECT_HOLE and 
    o.oInteractStatus ~= ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED then
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
    end
end

----------------------------
--BOWSER IN THE DARK WORLD--
----------------------------

function leg_bomb_interact_bowser(o, explosionPos)
    if ((o.oMoveFlags & OBJ_MOVE_ON_GROUND) ~= 0
     or (o.oMoveFlags & OBJ_MOVE_LANDED) ~= 0
     or (o.oMoveFlags & OBJ_MOVE_HIT_EDGE) ~= 0) and o.oAction ~= 4 then
        local angle = atan2s(o.oPosZ - explosionPos.z, o.oPosX - explosionPos.x)
        o.oVelY = 40
        o.oForwardVel = 60
        o.oMoveAngleYaw = angle
        o.oMoveFlags = 0
        o.oAction = 1
        --network_send_object(o, false)
    end
end


-----------------------------------------------------------------
-----------------------------------------------------------------
----- INTERACTIONS HANDLING -------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

explosionhurtableenemy = {
    -- NPCs
    [id_bhvBobombBuddy] = leg_bomb_interact_bobomb_buddy,
    [id_bhvBobombBuddyOpensCannon] = leg_bomb_interact_bobomb_buddy,
    [id_bhvToadMessage] = leg_bomb_interact_general_npc,
    [id_bhvYoshi] = leg_bomb_interact_general_npc,
    [id_bhvUkiki] = leg_bomb_interact_general_npc,
    [id_bhvHoot] = leg_bomb_interact_general_npc,
    [id_bhvPenguinBaby] = leg_bomb_interact_general_npc,
    [id_bhvSmallPenguin] = leg_bomb_interact_general_npc,
    [id_bhvSLWalkingPenguin] = leg_bomb_interact_general_npc,
    [id_bhvTuxiesMother] = leg_bomb_interact_general_npc,
    [id_bhvRacingPenguin] = leg_bomb_interact_general_npc,
    [id_bhvMips] = leg_bomb_interact_mips,
    [id_bhvUkikiCage] = leg_bomb_interact_ukiki_cage,
    -- BOB
    [id_bhvGoomba] = leg_bomb_interact_goomba, 
    [id_bhvKoopa] = leg_bomb_interact_koopa,
    [id_bhvBobomb] = leg_bomb_interact_bobomb,
    [id_bhvChainChomp] = leg_bomb_interact_chainchomp,
    [id_bhvWaterBomb] = leg_bomb_interact_waterbomb,
    [id_bhvKingBobomb] = leg_bomb_interact_kingbobomb,
    [id_bhvBreakableBox] = leg_bomb_interact_breakablebox,
    [id_bhvBreakableBoxSmall] = leg_bomb_interact_breakableboxsmall,
    [id_bhvExclamationBox] = leg_bomb_interact_breakableboxsmall,
    -- WF
    [id_bhvKickableBoard] = leg_bomb_interact_bridge,
    [id_bhvWfBreakableWallLeft] = leg_bomb_interact_breakablebox,
    [id_bhvWfBreakableWallRight] = leg_bomb_interact_breakablebox,
    [id_bhvSmallWhomp] = leg_bomb_interact_whomp,
    [id_bhvWhompKingBoss] = leg_bomb_interact_whompking,
    [id_bhvPiranhaPlant] = leg_bomb_interact_piranhaplant,
    [id_bhvBulletBill] = leg_bomb_interact_bulletbill,
    -- CM
    [id_bhvSpindrift] = leg_bomb_interact_enemygeneral,
    [id_bhvMrBlizzard] = leg_bomb_interact_mrblizzard,
    -- BBH
    [id_bhvBoo] = leg_bomb_interact_enemygeneral,
    [id_bhvGhostHuntBoo] = leg_bomb_interact_enemygeneral,
    [id_bhvFlyingBookend] = leg_bomb_interact_enemygeneral,
    [id_bhvHauntedChair] = leg_bomb_interact_enemygeneral,
    [id_bhvBooInCastle] = leg_bomb_interact_enemygeneral,
    [id_bhvBooWithCage] = leg_bomb_interact_enemygeneral,
    [id_bhvMerryGoRoundBoo] = leg_bomb_interact_enemygeneral,
    [id_bhvBalconyBigBoo] = leg_bomb_interact_enemygeneral,
    [id_bhvGhostHuntBigBoo] = leg_bomb_interact_enemygeneral,
    [id_bhvMerryGoRoundBigBoo] = leg_bomb_interact_enemygeneral,
    [id_bhvMadPiano] = leg_bomb_interact_madpiano,
    -- LLL
    [id_bhvMrI] = leg_bomb_interact_mri,
    [id_bhvSmallBully] = leg_bomb_interact_bully,
    [id_bhvBigBully] = leg_bomb_interact_bully,
    [id_bhvBigBullyWithMinions] = leg_bomb_interact_bully,
    -- SSL
    [id_bhvPokey] = leg_bomb_interact_enemygeneral,
    [id_bhvPokeyBodyPart] = leg_bomb_interact_enemygeneral,
    [id_bhvKlepto] = leg_bomb_interact_klepto,
    [id_bhvFlyGuy] = leg_bomb_interact_enemygeneral,
    [id_bhvEyerokHand] = leg_bomb_interact_enemygeneral,
    [id_bhvJumpingBox] = leg_bomb_interact_jumping_box,
    -- HMZ
    [id_bhvScuttlebug] = leg_bomb_interact_enemygeneral,
    [id_bhvSnufit] = leg_bomb_interact_enemygeneral,
    [id_bhvSwoop] = leg_bomb_interact_enemygeneral,
    -- THI
    [id_bhvFirePiranhaPlant] = leg_bomb_interact_firepiranhaplant,
    [id_bhvChuckya] = leg_bomb_interact_chuckya,
    [id_bhvEnemyLakitu] = leg_bomb_interact_enemygeneral,
    [id_bhvSpiny] = leg_bomb_interact_spiny,
    [id_bhvWigglerBody] = leg_bomb_interact_klepto,
    [id_bhvWigglerHead] = leg_bomb_interact_klepto,
    -- TTM
    [id_bhvMontyMole] = leg_bomb_interact_monty_mole,
    -- WDW
    [id_bhvSkeeter] = leg_bomb_interact_enemygeneral,
    -- SL
    [id_bhvSmallChillBully] = leg_bomb_interact_bully,
    [id_bhvBigChillBully] = leg_bomb_interact_bully,
    [id_bhvMoneybag] = leg_bomb_interact_enemygeneral,
    -- BOWSER
    [id_bhvBowser] = leg_bomb_interact_bowser,
}

function explosionattack(obj)
    local hurtenemy = false
    local enemyobj

    local actualtable = explosionhurtableenemy
    -- Detect if SR enemies are present
    if (bhvSMSRShyGuy) then
        actualtable[bhvSMSRSmallBee] = leg_bomb_interact_enemygeneral
        actualtable[bhvSMSRShyGuy] = leg_bomb_interact_goomba
        actualtable[bhvSMSRAttractedSpaceBox] = leg_bomb_interact_madpiano
        actualtable[bhvSMSRYoshi] = leg_bomb_interact_general_npc
        actualtable[bhvSMSRPeachMessage] = leg_bomb_interact_general_npc
    end
    
    for key,value in pairs(actualtable) do --actualtable is a table of enemies that can be hurt by explosions with each enemy stored by behaviorid
        enemyobj = obj_get_nearest_object_with_behavior_id(obj,key) --get nearest hitable obj
        if enemyobj ~= nil and obj_check_hitbox_overlap(obj, enemyobj) then --check if obj is touching enemy obj
            hurtenemy = true --obj hit enemyobj
            if actualtable[key] then
                local explosionPos = {x = obj.oPosX, z = obj.oPosZ}
                actualtable[key](enemyobj, explosionPos)
            end
        end
    end
    return hurtenemy
end

function explosion_check_interact_other_players(obj)
    local np = network_player_from_global_index(obj.oOwner)
    local m = gMarioStates[np.localIndex]
    local player = nearest_mario_state_to_object(obj)
    if player ~= nil and obj_check_hitbox_overlap(obj, player.marioObj) and player.playerIndex ~= m.playerIndex then
        if _G.HideAndSeek then
            if _G.HideAndSeek.is_player_seeker(m.playerIndex) and not _G.HideAndSeek.is_player_seeker(player.playerIndex) then
                _G.HideAndSeek.set_player_seeker(player.playerIndex, true)
            end
        end
    end
end

function spawn_napalm(m, grounded)
    mmx_play_sound(SOUND_VILE_NAPALM_SHOT, m.pos, 0.47)
    local mGfx = m.marioObj.header.gfx
    local angl = m.faceAngle.y - 6000
    if (grounded) then
        spawn_non_sync_object(id_bhvLegNapalm, E_model_leg_napalm, mGfx.pos.x + sins(angl) * 50, mGfx.pos.y + 10, mGfx.pos.z + coss(angl) * 50 , function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oForwardVel = 90
            obj.oVelY = 25
        end)
    else
        spawn_non_sync_object(id_bhvLegNapalm, E_model_leg_napalm, mGfx.pos.x + sins(angl) * 50, mGfx.pos.y + 10, mGfx.pos.z + coss(angl) * 50 , function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oForwardVel = 34
        end)
    end
end

-----------------------------------------------------------------
-----------------------------------------------------------------
----- BEHAVIORS -------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

--- LEG NAPALM
local leg_napalm_init = function(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oBuoyancy = 3.5
    obj_scale(o, 0.7)
    o.oGraphYOffset = 20
    o.oGravity = 5
    o.oFriction = 0.8
end

local leg_napalm_loop = function(o)
    if o.oTimer < 18 then
        object_step()
    end
    if o.oTimer == 18 then
        cur_obj_hide()
        spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_BOWSER_FLAMES, o.oPosX , o.oPosY + 20 , o.oPosZ, function(obj)
            obj.header.gfx.scale.x = 2.5
            obj.header.gfx.scale.y = 6
            obj.header.gfx.scale.z = 2.5
            obj.oOpacity = 200
        end)
    end
    if o.oTimer >= 20 then
        spawn_non_sync_object(id_bhvLegNapalmExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, function(obj)
            obj.oOwner = o.oOwner
        end)
        obj_mark_for_deletion(o)
    end
end

-- LEG NAPALM EXPLOSION
local leg_napalm_explosion_init = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.node.flags = o.header.gfx.node.flags | GRAPH_RENDER_BILLBOARD
    --create_sound_spawner(o, SOUND_GENERAL2_BOBOMB_EXPLOSION)
    mmx_play_sound(SOUND_VILE_NAPALM_EXPLODE, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, 0.75)
    set_environmental_camera_shake(SHAKE_ENV_EXPLOSION)
    for i = 0, 8, 1 do
        local angle = 8192 * i
        spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_EXPLOSION, o.oPosX + 150 * sins(angle), o.oPosY + 50, o.oPosZ + 150 * coss(angle), function(obj)
            obj.header.gfx.scale.x = 0.5
            obj.header.gfx.scale.y = 0.5
            obj.header.gfx.scale.z = 0.5
            obj.oOpacity = 200
        end)
    end
    spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, function(obj)
        obj.header.gfx.scale.x = 1.3
        obj.header.gfx.scale.y = 1.1
        obj.header.gfx.scale.z = 1.3
        obj.oOpacity = 200
    end)
    o.oOpacity = 255
    o.header.gfx.scale.x = 1.7
    o.header.gfx.scale.y = 2.3
    o.header.gfx.scale.z = 1.7
    if (m.playerIndex ~= 0) then
        o.oIntangibleTimer = 3
        o.oInteractType = INTERACT_DAMAGE
        if gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP then
            o.oDamageOrCoinValue = 3
        end
    end
    o.hitboxRadius            = 300
    o.hitboxHeight            = 620
    o.hitboxDownOffset        = 200
    o.oGraphYOffset = 200
end

local leg_napalm_explosion_loop = function(o)
    o.header.gfx.scale.x = 1.1
    o.header.gfx.scale.y = 1.45
    o.header.gfx.scale.z = 1.1

    explosion_check_interact_other_players(o)

    if (o.oTimer > 2) then
        explosionattack(o)
    end
    o.oAnimState = o.oAnimState + 1
    if (o.oTimer == 9) then
        if (find_water_level(o.oPosX, o.oPosZ) > o.oPosY) then
            for i = 0, 40, 1 do 
                --spawn_object(o, MODEL_WHITE_PARTICLE_SMALL, bhvBobombExplosionBubble)
                spawn_non_sync_object(id_bhvBobombExplosionBubble, E_MODEL_WHITE_PARTICLE_SMALL, o.oPosX, o.oPosY, o.oPosZ, nil)
            end                
        else
            --spawn_object(o, MODEL_SMOKE, bhvBobombBullyDeathSmoke)
            spawn_non_sync_object(id_bhvBobombBullyDeathSmoke, E_MODEL_SMOKE, o.oPosX, o.oPosY + 200, o.oPosZ, nil)
        end
        o.activeFlags = ACTIVE_FLAG_DEACTIVATED
    end

    o.oOpacity = o.oOpacity - 14

    cur_obj_scale(o.oTimer / 9.0 + 1.0)
end

----------------------------
--BEHAVIORS REGISTRY--------
----------------------------
id_bhvLegNapalm = hook_behavior(nil, OBJ_LIST_GENACTOR, false, leg_napalm_init, leg_napalm_loop)
id_bhvLegNapalmExplosion = hook_behavior(nil, OBJ_LIST_GENACTOR, false, leg_napalm_explosion_init, leg_napalm_explosion_loop)