-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local math_sin, math_cos, sins, coss, network_player_from_global_index, obj_mark_for_deletion, obj_spawn_loot_yellow_coins,
 network_send_object, mmx_play_sound,
 nearest_mario_state_to_object, obj_get_nearest_object_with_behavior_id, obj_check_hitbox_overlap, obj_scale, collision_find_surface_on_ray =
 math.sin, math.cos, sins, coss, network_player_from_global_index, obj_mark_for_deletion, obj_spawn_loot_yellow_coins,
  network_send_object, mmx_play_sound,
  nearest_mario_state_to_object, obj_get_nearest_object_with_behavior_id, obj_check_hitbox_overlap, obj_scale, collision_find_surface_on_ray

-----------------------------------------------------------------
-----------------------------------------------------------------
----- INTERACTIONS ----------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

-------------------
--GENERAL ENEMIES--
-------------------

function shot_interact_chuckya(o, shot_level, shot_dir)
    if shot_level == 3 then
        o.usingObj = nil
        obj_mark_for_deletion(o)
        obj_spawn_loot_yellow_coins(o, 5, 20.0)
        spawn_mist_particles_with_sound(SOUND_OBJ_CHUCKYA_DEATH)
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_enemygeneral(o, shot_level, shot_dir)
    if (o.oInteractStatus & INT_STATUS_INTERACTED) == 0 
    and o.oAction ~= OBJ_ACT_VERTICAL_KNOCKBACK and o.oAction ~= OBJ_ACT_HORIZONTAL_KNOCKBACK and o.oAction ~= OBJ_ACT_SQUISHED then
        if shot_level == 1 then
            o.oInteractStatus =  ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        elseif shot_level == 2 then
            o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        else
            o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        end
        --network_send_object(o, false)
        return true
    else
        return false
    end
end

function shot_interact_bigenemygeneral(o, shot_level, shot_dir)
    if shot_level > 1 then
        if (o.oInteractStatus & INT_STATUS_INTERACTED) == 0 then
            o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
            --network_send_object(o, false)
            return true
        else
            return false
        end
    else
        return true
    end
end

-----------------------
--BOB-OMB BATTLEFIELD--
-----------------------

function shot_interact_bobomb(o, shot_level, shot_dir)
    if (o.oAction ~= BOBOMB_ACT_EXPLODE) then
        if shot_level == 1 then
            if (o.oVelY <= 0) then
                o.oMoveAngleYaw = shot_dir
                o.oForwardVel = 15.0
                o.oVelY = 20.0
                o.oAction = BOBOMB_ACT_LAUNCHED
            end
        else
            o.oAction = BOBOMB_ACT_EXPLODE
        end
        --network_send_object(o, false)
        return true
    else
        return false
    end
end

function shot_interact_chainchomp(o, shot_level, shot_dir)
    if shot_level == 3  then
        o.oSubAction = CHAIN_CHOMP_SUB_ACT_LUNGE
        o.oChainChompMaxDistFromPivotPerChainPart = 900.0 / 5
        o.oForwardVel = 0.0
        o.oVelY = 300.0
        o.oGravity = -4.0
        o.oChainChompTargetPitch = -0x3000
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_waterbomb(o, shot_level, shot_dir)
    if shot_level > 1 then
        o.oAction = WATER_BOMB_ACT_EXPLODE
    end
    return true
end

function shot_interact_kingbobomb(o, shot_level, shot_dir)
    if shot_level == 3 and (o.oFlags & OBJ_FLAG_HOLDABLE) ~= 0 and o.oAction ~= 8 then
        o.oVelY = 30
        o.oForwardVel = 30
        o.oMoveAngleYaw = shot_dir
        o.oMoveFlags = 0
        o.oAction = 4
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_breakablebox(o, shot_level, shot_dir)
    if shot_level > 1 then
        o.oInteractStatus =  ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_breakableboxsmall(o, shot_level, shot_dir)
    if shot_level > 1 then
        o.oInteractStatus = ATTACK_KICK_OR_TRIP | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_exclamationbox(o, shot_level, shot)
    if o.oAction ~= 5 and o.oAction ~= 6 then
        if shot_level > 1 then
            o.oInteractStatus = ATTACK_KICK_OR_TRIP | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
            --network_send_object(o, false)
        end
        return true
    else
        return false
    end
end

--------------------
--WHOMP'S FORTRESS--
--------------------

function shot_interact_bridge(o, shot_level, shot_dir)
    if shot_level == 3 and (o.oFaceAnglePitch > -0x4000) then
        o.oAction = 2
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_whomp(o, shot_level, shot_dir)
    if o.oAction ~= 8 and shot_level == 3 then
        o.oNumLootCoins = 5
        obj_spawn_loot_yellow_coins(o, 5, 20.0)
        o.oAction = 8
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_whompking(o, shot_level, shot_dir)
    if o.oAction ~= 8 and o.oAction ~= 0 and shot_level == 3 then
        o.oHealth = o.oHealth - 1
        play_sound(SOUND_OBJ2_WHOMP_SOUND_SHORT, o.header.gfx.cameraToObject)
        play_sound(SOUND_OBJ_KING_WHOMP_DEATH, o.header.gfx.cameraToObject)
        if (o.oHealth == 0) then
            o.oAction = 8
        end
        --network_send_object(o, false)
    end
    return true
end

function shot_interact_piranhaplant(o, shot_level, shot_dir)
    stop_secondary_music(50)
    if o.oAction ~= PIRANHA_PLANT_ACT_SHRINK_AND_DIE 
    and o.oAction ~= PIRANHA_PLANT_ACT_ATTACKED and o.oAction ~= PIRANHA_PLANT_ACT_WAIT_TO_RESPAWN then
        if shot_level == 1 then
            o.oAction = PIRANHA_PLANT_ACT_WOKEN_UP
        else
            o.oAction = PIRANHA_PLANT_ACT_ATTACKED
        end
        --network_send_object(o, false)
        return true
    end
    return false
end

function shot_interact_bulletbill(o, shot_level, shot_dir)
    if shot_level == 2 then
        o.oAction = 4
    elseif shot_level == 3 then
        o.oAction = 3
        spawn_non_sync_object(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, nil)
    end
    --network_send_object(o, false)
    return true
end

----------------------
--COOL COOL MOUNTAIN--
----------------------

function shot_interact_mrblizzard(o, shot_level, shot_dir)
    if o.oAction ~= MR_BLIZZARD_ACT_DEATH then
        if shot_level == 3 then
            o.oAction = MR_BLIZZARD_ACT_DEATH
            --network_send_object(o, false)
        end
        return true
    end
    return false
end

----------------------
--SHIFTING SAND LAND--
----------------------
function shot_interact_klepto(o, shot_level, shot_dir)
    if shot_level == 3 then
        o.oInteractStatus = ATTACK_FROM_ABOVE | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
        --network_send_object(o, false)
    end
    return true
end

function leg_bomb_interact_jumping_box(o, shot_level, shot_dir)
    if shot_level > 1 and o.oInteractStatus ~= INT_STATUS_STOP_RIDING then
        o.oInteractStatus = INT_STATUS_STOP_RIDING
    end
end

--------------------
--LETHAL LAVA LAND--
--------------------
function shot_interact_mri(o, shot_level, shot_dir)
    if (o.oAction ~= 3) then
        if shot_level == 3 then
            o.oAction = 3
            o.oTimer = 104
            --network_send_object(o, false)
        end
        return true
    end
    return false
end

function shot_interact_bully(o, shot_level, shot_dir)
    o.oMoveAngleYaw = shot_dir
    if shot_level == 1 then
        o.oInteractStatus = INT_STATUS_INTERACTED
        o.oForwardVel = 15
    elseif shot_level == 2 then
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        o.oForwardVel = 30
    else
        o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        o.oForwardVel = 50
    end
    --network_send_object(o, false)
    return true
end

---------------------
---TINY HUGE ISLAND--
---------------------

function shot_interact_spiny(o, shot_level, shot_dir)
    if shot_level == 1 then
        o.oInteractStatus =  ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    else
        spawn_mist_particles()
        play_sound(SOUND_OBJ_DEFAULT_DEATH, o.header.gfx.cameraToObject)
        o.oNumLootCoins = 1
        obj_spawn_loot_yellow_coins(o, 1, 20.0);
        obj_mark_for_deletion(o)
    end
    --network_send_object(o, false)
    return true
end

function leg_bomb_interact_firepiranhaplant(o, shot_level, shot_dir)
    if o.oAction ~= FIRE_PIRANHA_PLANT_ACT_HIDE then
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
        return true
    end
    return false
end

------------------------
---TALL TALL MOUNTAIN---
------------------------

function shot_interact_monty_mole(o, explosionPos)
    if o.oAction ~= MONTY_MOLE_ACT_SELECT_HOLE and 
    o.oInteractStatus ~= ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED then
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        --network_send_object(o, false)
    end
end

----------------------------
--BOWSER IN THE DARK WORLD--
----------------------------

function shot_interact_bowser(o, shot_level, shot_dir)
    if shot_level == 3 and ((o.oMoveFlags & OBJ_MOVE_ON_GROUND) ~= 0
     or (o.oMoveFlags & OBJ_MOVE_LANDED) ~= 0
     or (o.oMoveFlags & OBJ_MOVE_HIT_EDGE) ~= 0) and o.oAction ~= 4 then
        o.oVelY = 40
        o.oForwardVel = 60
        o.oMoveAngleYaw = shot_dir
        o.oMoveFlags = 0
        o.oAction = 1
        --network_send_object(o, false)
    end
    return true
end


-----------------------------------------------------------------
-----------------------------------------------------------------
----- INTERACTIONS HANDLING -------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

projectilehurtableenemy = {
    -- BOB
    [id_bhvGoomba] = shot_interact_enemygeneral, 
    [id_bhvKoopa] = shot_interact_enemygeneral,
    [id_bhvBobomb] = shot_interact_bobomb,
    [id_bhvChainChomp] = shot_interact_chainchomp,
    [id_bhvWaterBomb] = shot_interact_waterbomb,
    [id_bhvKingBobomb] = shot_interact_kingbobomb,
    [id_bhvBreakableBox] = shot_interact_breakablebox,
    [id_bhvBreakableBoxSmall] = shot_interact_breakableboxsmall,
    [id_bhvExclamationBox] = shot_interact_exclamationbox,
    -- WF
    [id_bhvKickableBoard] = shot_interact_bridge,
    [id_bhvWfBreakableWallLeft] = shot_interact_breakablebox,
    [id_bhvWfBreakableWallRight] = shot_interact_breakablebox,
    [id_bhvSmallWhomp] = shot_interact_whomp,
    [id_bhvWhompKingBoss] = shot_interact_whompking,
    [id_bhvPiranhaPlant] = shot_interact_piranhaplant,
    [id_bhvBulletBill] = shot_interact_bulletbill,
    -- CM
    [id_bhvSpindrift] = shot_interact_enemygeneral,
    [id_bhvMrBlizzard] = shot_interact_mrblizzard,
    -- BBH
    [id_bhvBoo] = shot_interact_enemygeneral,
    [id_bhvGhostHuntBoo] = shot_interact_enemygeneral,
    [id_bhvFlyingBookend] = shot_interact_enemygeneral,
    [id_bhvHauntedChair] = shot_interact_enemygeneral,
    [id_bhvBooInCastle] = shot_interact_enemygeneral,
    [id_bhvBooWithCage] = shot_interact_enemygeneral,
    [id_bhvMerryGoRoundBoo] = shot_interact_bigenemygeneral,
    [id_bhvBalconyBigBoo] = shot_interact_bigenemygeneral,
    [id_bhvGhostHuntBigBoo] = shot_interact_bigenemygeneral,
    [id_bhvMerryGoRoundBigBoo] = shot_interact_bigenemygeneral,
    -- LLL
    [id_bhvMrI] = shot_interact_mri,
    [id_bhvSmallBully] = shot_interact_bully,
    [id_bhvBigBully] = shot_interact_bully,
    [id_bhvBigBullyWithMinions] = shot_interact_bully,
    -- SSL
    [id_bhvPokey] = shot_interact_enemygeneral,
    [id_bhvPokeyBodyPart] = shot_interact_enemygeneral,
    [id_bhvKlepto] = shot_interact_klepto,
    [id_bhvFlyGuy] = shot_interact_enemygeneral,
    [id_bhvEyerokHand] = shot_interact_bigenemygeneral,
    [id_bhvJumpingBox] = leg_bomb_interact_jumping_box,
    -- HMZ
    [id_bhvScuttlebug] = shot_interact_enemygeneral,
    [id_bhvSnufit] = shot_interact_enemygeneral,
    [id_bhvSwoop] = shot_interact_enemygeneral,
    -- THI
    [id_bhvFirePiranhaPlant] = leg_bomb_interact_firepiranhaplant,
    [id_bhvChuckya] = shot_interact_chuckya,
    [id_bhvEnemyLakitu] = shot_interact_enemygeneral,
    [id_bhvSpiny] = shot_interact_spiny,
    [id_bhvWigglerBody] = shot_interact_klepto,
    [id_bhvWigglerHead] = shot_interact_klepto,
    -- TTM
    [id_bhvMontyMole] = shot_interact_monty_mole,
    -- WDW
    [id_bhvSkeeter] = shot_interact_enemygeneral,
    -- SL
    [id_bhvSmallChillBully] = shot_interact_bully,
    [id_bhvBigChillBully] = shot_interact_bully,
    [id_bhvMoneybag] = shot_interact_enemygeneral,
    -- BOWSER
    [id_bhvBowser] = shot_interact_bowser,
}

function projectileattack(obj, shot_level, shot_dir)
    local hurtenemy = false
    local enemyobj

    local actualtable = projectilehurtableenemy
    -- Detect if SR enemies are present
    if (bhvSMSRShyGuy) then
        actualtable[bhvSMSRSmallBee] = shot_interact_enemygeneral
        actualtable[bhvSMSRShyGuy] = shot_interact_enemygeneral
    end
    
    for key,value in pairs(actualtable) do --actualtable is a table of enemies that can be hurt by projectiles with each enemy stored by behaviorid
        enemyobj = obj_get_nearest_object_with_behavior_id(obj,key) --get nearest hitable obj
        if enemyobj ~= nil and obj_check_hitbox_overlap(obj, enemyobj) then --check if obj is touching enemy obj
            if actualtable[key] then
                hurtenemy = actualtable[key](enemyobj, shot_level, shot_dir)
            end
        end
    end
    return hurtenemy
end

function projectile_hit_other_players(obj, shot_level)
    local np = network_player_from_global_index(obj.oOwner)
    local m = gMarioStates[np.localIndex]
    local player = nearest_mario_state_to_object(obj)
    if player ~= nil and obj_check_hitbox_overlap(obj, player.marioObj) and player.playerIndex ~= m.playerIndex then
        if _G.HideAndSeek and shot_level > 1 then
            if _G.HideAndSeek.is_player_seeker(m.playerIndex) and not _G.HideAndSeek.is_player_seeker(player.playerIndex) then
                _G.HideAndSeek.set_player_seeker(player.playerIndex, true)
            end
        end
        return true
    end
    return false
end

function spawn_shot(m, armHeight, armLength, armTheta, chargeLevel)
    local mGfx = m.marioObj.header.gfx
    local s = gPlayerSyncTable[m.playerIndex]
    if chargeLevel == 0 then
        local busterSpawnTheta = ((m.faceAngle.y + armTheta) / 0x8000) * math.pi
        local busterXOffset =  math_sin(busterSpawnTheta) * armLength
        local busterZOffset =  math_cos(busterSpawnTheta) * armLength
        if (s.character == 'x') then
            mmx_play_sound(SOUND_X_SHOT1, m.pos, 0.57)
            spawn_non_sync_object(id_bhvShot, E_model_shot1, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset, function(obj)
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oShotDestroyNextFrame = 0
                obj.oShotChar = 0
                obj.oShotLevel = 1
            end)
        elseif (s.character == 'vile') then
            mmx_play_sound(SOUND_VILE_SHOT, m.pos, 0.44)
            spawn_non_sync_object(id_bhvShot, E_model_vulcan_shot, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset, function(obj)
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oShotDestroyNextFrame = 0
                obj.oShotChar = 1
                obj.oShotLevel = 1
            end)
        end
    elseif chargeLevel == 1 then
        mmx_play_sound(SOUND_X_SHOT2, m.pos, 0.75)
        local busterSpawnTheta = ((m.faceAngle.y + armTheta) / 0x8000) * math.pi
        local busterXOffset =  math_sin(busterSpawnTheta) * armLength
        local busterZOffset =  math_cos(busterSpawnTheta) * armLength
        spawn_non_sync_object(id_bhvShot, E_model_shot2, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset, function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oShotDestroyNextFrame = 0
            obj.oShotChar = 0
            obj.oShotLevel = 2
        end)
    elseif chargeLevel == 2 then
        local busterSpawnTheta = ((m.faceAngle.y + armTheta) / 0x8000) * math.pi
        local busterXOffset =  math_sin(busterSpawnTheta) * armLength
        local busterZOffset =  math_cos(busterSpawnTheta) * armLength
        if (s.character == 'x') then
            mmx_play_sound(SOUND_X_SHOT3, m.pos, 0.75)
            spawn_non_sync_object(id_bhvShot, E_model_shot3, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset, function(obj)
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oShotDestroyNextFrame = 0
                obj.oShotChar = 0
                obj.oShotLevel = 3
            end)
        elseif (s.character == 'vile') then
            mmx_play_sound(SOUND_VILE_CANNON, m.pos, 0.54)
            spawn_non_sync_object(id_bhvShot, E_model_cannon_shot, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset, function(obj)
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oShotDestroyNextFrame = 0
                obj.oShotChar = 1
                obj.oShotLevel = 3
            end)
        end
    else
        mmx_play_sound(SOUND_X_SHOT_MAX, m.pos, 0.9)
        local busterSpawnTheta = ((m.faceAngle.y + armTheta) / 0x8000) * math.pi
        local busterSpawnTheta2 = ((m.faceAngle.y + armTheta - 10000) / 0x8000) * math.pi
        local busterXOffset =  math_sin(busterSpawnTheta) * armLength
        local busterZOffset =  math_cos(busterSpawnTheta) * armLength
        local busterXOffset2 =  sins(m.faceAngle.y + 16384) * 50
        local busterZOffset2 =  coss(m.faceAngle.y + 16384) * 50
        spawn_non_sync_object(id_bhvShot, E_model_shot_max, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset, function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oShotDestroyNextFrame = 0
            obj.oShotChar = 0
            obj.oChargeRot = 0
            obj.oShotLevel = 4
        end)
        spawn_non_sync_object(id_bhvShot, E_model_shot_max, mGfx.pos.x + busterXOffset, mGfx.pos.y + armHeight - 15, mGfx.pos.z + busterZOffset, function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oShotDestroyNextFrame = 0
            obj.oShotChar = 0
            obj.oLightArmorShotOffset = math.pi
            obj.oChargeRot = 0
            obj.oShotLevel = 4
        end)
        spawn_non_sync_object(id_bhvShot, E_model_shot_max, mGfx.pos.x + busterXOffset - busterXOffset2,
         mGfx.pos.y + armHeight, mGfx.pos.z + busterZOffset - busterZOffset2, function(obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oShotDestroyNextFrame = 0
            obj.oShotChar = 0
            obj.oChargeRot = 1
            obj.oShotLevel = 4
        end)
    end
end


-----------------------------------------------------------------
-----------------------------------------------------------------
----- BEHAVIORS -------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------


local shot_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    o.oWallHitboxRadius = 5.0 * o.oShotLevel
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    if o.oShotLevel == 1 then
        if o.oShotChar == 1 then
            o.header.gfx.scale.x = 0.4
            o.header.gfx.scale.z = 0.4
            o.header.gfx.scale.y = 0.4
        end
        if (m.playerIndex ~= 0) then
            o.oIntangibleTimer = 0
            if gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP then
                o.oInteractType = INTERACT_DAMAGE
                o.oDamageOrCoinValue = 0
            end
        end
        o.hitboxRadius            = 30
        o.hitboxHeight            = 50
        o.hitboxDownOffset        = 50
        o.oForwardVel = 92
    end
    if o.oShotLevel == 2 then
        o.header.gfx.scale.x = 1.15
        o.header.gfx.scale.z = 1.15
        o.header.gfx.scale.y = 1.15
        if (m.playerIndex ~= 0) then
            o.oIntangibleTimer = 0
            if gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP then
                o.oInteractType = INTERACT_DAMAGE
                o.oDamageOrCoinValue = 1
            end
        end
        o.hitboxRadius            = 70
        o.hitboxHeight            = 90
        o.hitboxDownOffset        = 70
        o.oForwardVel = 125
    end
    if o.oShotLevel == 3 then
        if (m.playerIndex ~= 0) then
            o.oInteractType = INTERACT_DAMAGE
            o.oIntangibleTimer = 0
            if gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP then
                o.oDamageOrCoinValue = 2
            end
        end
        o.hitboxRadius            = 130
        o.hitboxHeight            = 160
        o.hitboxDownOffset        = 110
        if (o.oShotChar == 0) then
            o.oForwardVel = 170
            spawn_non_sync_object(id_bhvShotRing, E_model_shot2_ring, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                obj.oForwardVel = 60
                obj.oMoveAngleYaw = o.oMoveAngleYaw
            end)
        elseif (o.oShotChar == 1) then
            o.oForwardVel = 140
            o.hitboxRadius            = 120
            o.hitboxHeight            = 150
            o.hitboxDownOffset        = 100
        end
    end
    if o.oShotLevel == 4 then
        o.oWallHitboxRadius = 10
        if (m.playerIndex ~= 0) then
            o.oInteractType = INTERACT_DAMAGE
            o.oIntangibleTimer = 0
            if gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP then
                o.oDamageOrCoinValue = 2
            end
        end
        o.hitboxRadius            = 87
        o.hitboxHeight            = 105
        o.hitboxDownOffset        = 80
        o.oForwardVel = 170
        spawn_non_sync_object(id_bhvCharge2Front, E_model_shot_max_bubble, o.oPosX, o.oPosY, o.oPosZ, function(obj)
            obj.oForwardVel = 60
            obj.oMoveAngleYaw = o.oMoveAngleYaw
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.oMoveAngleYaw = o.oMoveAngleYaw
        end)
        --spawn_non_sync_object(id_bhvShotRing, E_model_shot_max_ring, o.oPosX, o.oPosY + 40, o.oPosZ, function(obj)
        --    obj.oForwardVel = 60
        --    obj.oMoveAngleYaw = o.oMoveAngleYaw
        --end)
    end
    o.oVelX = sins(o.oMoveAngleYaw) * o.oForwardVel
    o.oVelY = 0
    o.oVelZ = coss(o.oMoveAngleYaw) * o.oForwardVel
    --obj_set_hitbox_radius_and_height(o, radius, height)
end

local shot_loop = function(o)
    local shotlvl = o.oShotLevel
    if (o.oShotLevel == 4) then
        shotlvl = 3
    end
    if projectileattack(o, shotlvl, o.oMoveAngleYaw) then --if banana hits obj
        --o.oAction = BOBOMB_ACT_EXPLODE
        obj_mark_for_deletion(o)
    end
    if o.oShotDestroyNextFrame == 1 then
        obj_mark_for_deletion(o)
    end
    local shot_speed
    local shot_life
    if o.oShotLevel == 1 then
        if (o.oShotChar == 0) then
            shot_life = 35
        elseif (o.oShotChar == 1) then
            shot_life = 25
        end
    elseif o.oShotLevel ==  2 then
        shot_life = 37
    elseif o.oShotLevel == 3 then
        obj_scale(o, 1.3)
        shot_life = 45
        o.oMoveAngleRoll = o.oMoveAngleRoll + 4000 + 6000 / (o.oTimer * o.oTimer)
        if o.oTimer % 4 and o.oShotChar == 0 then
            local shotTheta = o.oMoveAngleYaw / 0x8000 * math.pi
            local randomY = math.random(-50, 50)
            local randomPitch = math.random(-4000, 4000)
            spawn_non_sync_object(id_bhvShotTrailBall, E_model_shot2, o.oPosX - 40 * math_sin(shotTheta + randomPitch), o.oPosY + randomY, o.oPosZ - 40 * math_cos(shotTheta + randomPitch), function(obj)
                obj.oForwardVel = 60
                obj.oMoveAngleYaw = o.oMoveAngleYaw
                obj.oShotLevel = 3
            end)
        end
        if o.oTimer % 3 == 0 then
            o.header.gfx.scale.y = 1.3;
        elseif o.oTimer % 2 == 0 then
            o.header.gfx.scale.x = 1.3
            o.header.gfx.scale.z = 1.3
        end
    elseif o.oShotLevel == 4 then
        obj_scale(o, 1.4)
        shot_life = 50
        if o.oTimer then
            spawn_non_sync_object(id_bhvShotTrailBall, E_model_shot_max, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                obj.oForwardVel = 60
                obj.oMoveAngleYaw = o.oMoveAngleYaw
                obj.oShotLevel = 4
            end)
        end
    end
    local prevPosX = o.oPosX
    local prevPosZ = o.oPosZ
    
    local collision = collision_find_surface_on_ray(
        o.oPosX, o.oPosY, o.oPosZ,
        o.oVelX, o.oVelY, o.oVelZ)
    
    --djui_chat_message_create(tostring(collide))
    if collision.surface ~= nil or projectile_hit_other_players(o, shotlvl) then
        o.oShotDestroyNextFrame = 1
    else
        local ang = (o.oMoveAngleYaw / 0x8000) * math.pi
        if (o.oShotLevel == 4) then
            if o.oChargeRot == 0 then
                o.oPosX = o.oPosX + o.oVelX + 65 * math_sin(ang + o.oTimer - o.oLightArmorShotOffset + math.pi / 2)
                o.oPosY = o.oPosY + o.oVelY + 65 * math_sin(o.oTimer)
                o.oPosZ = o.oPosZ + o.oVelZ + 65 * math_cos(ang + o.oTimer - o.oLightArmorShotOffset + math.pi / 2)
            else
                o.oPosX = o.oPosX + o.oVelX + 65 * math_sin(ang + o.oTimer - o.oLightArmorShotOffset)
                o.oPosY = o.oPosY + o.oVelY + 65 * math_cos(o.oTimer)
                o.oPosZ = o.oPosZ + o.oVelZ + 65 * math_cos(ang + o.oTimer - o.oLightArmorShotOffset)
            end
        else
            o.oPosX = o.oPosX + o.oVelX
            o.oPosY = o.oPosY + o.oVelY
            o.oPosZ = o.oPosZ + o.oVelZ
        end
    end

    if o.oTimer >= shot_life then
        obj_mark_for_deletion(o)
    end
end

----------------------------
--BEHAVIORS REGISTRY--------
----------------------------
id_bhvShot = hook_behavior(nil, OBJ_LIST_GENACTOR, false, shot_init, shot_loop)