-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround, smlua_anim_util_set_animation,
mmx_play_sound =
network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround, smlua_anim_util_set_animation,
mmx_play_sound

---------------------------------------------------------------
--- INIT ------------------------------------------------------
---------------------------------------------------------------
E_model_x = smlua_model_util_get_id("x_geo")
E_model_x_defaulthands = smlua_model_util_get_id("x_defaulthands_geo")
E_model_x_alpha_jump = smlua_model_util_get_id("x_alpha_jump_geo")
E_model_x_alpha_gp = smlua_model_util_get_id("x_alpha_gp_geo")
E_model_x_alpha_dash = smlua_model_util_get_id("x_alpha_dash_geo")

E_model_x_lightarmor = smlua_model_util_get_id("x_lightarmor_geo")
E_model_x_lightarmor_defaulthands = smlua_model_util_get_id("x_lightarmor_defaulthands_geo")

local X_SHOOT_IASA = 4
local X_SHOOT_DURATION = 8

---------------------------------------------------------------
--- ACTIONS ---------------------------------------------------
---------------------------------------------------------------

-- DECLARATION
ACT_VAD_UP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)


-- DEFINITION
function act_vad_up(m)
    if (m.actionTimer == 1) then
        mario_set_forward_vel(m, m.forwardVel / 2)
    end
    smlua_anim_util_set_animation(m.marioObj, "x_vad_up")
    set_anim_to_frame(m, m.actionTimer)
    m.actionTimer = m.actionTimer + 1
    if m.actionTimer <= 10 then
        m.vel.y = 4
        if perform_air_step(m, 0) == AIR_STEP_LANDED then
            mario_set_forward_vel(m, 0.0)
            if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
                return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
            end
        end
    else
        if m.actionTimer == 11 then
            m.vel.y = 44
        end
        if (m.vel.y > 0) then
            common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
        else
            common_air_action_step(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
        end
        if (m.actionTimer > 23 or ((m.input & INPUT_A_DOWN) == 0 and m.actionTimer > 17)) then
            return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
        end
    end
end


-- ACTION HOOKS
hook_mario_action(ACT_VAD_UP,                       { every_frame = act_vad_up})

---------------------------------------------------------------
--- FUNCTIONS -------------------------------------------------
---------------------------------------------------------------

function mmx_x_on_area_change()
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.playerIndex == 0) then
        if (s.x_charge_spawned > 0) then
            s.x_charge_spawned = s.x_charge_spawned - 1
        end
    end
end

hook_event(HOOK_ON_LEVEL_INIT, mmx_x_on_area_change)
hook_event(HOOK_ON_WARP, mmx_x_on_area_change)

function mmx_x_store_colors(m)
    local s = gPlayerSyncTable[m.playerIndex]
    for i = 0, PLAYER_PART_MAX - 1 do
        local color = {r = 0, g = 0, b = 0}
        network_player_get_palette_color(nil, i, color)
        s.colorR[i] = color.r
        s.colorG[i] = color.g
        s.colorB[i] = color.b
    end
end

function mmx_x_apply_colors(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local x_defaultcolors = {
        -- PANTS
        [0] = {r = 114, g = 215, b = 238},
        -- SHIRT
        [1] = {r = 0, g = 128, b = 210},
        -- GLOVES
        [2] = {r = 255, g = 255, b = 255},
        -- SHOES
        [3] = {r = 255, g = 39, b = 31},
        -- HAIR
        [4] = {r = 113, g = 113, b = 113},
        -- SKIN
        [5] = {r = 255, g = 255, b = 255},
        -- CAP
        [6] = {r = 158, g = 181, b = 248},
        -- EMBLEM
        [7] = {r = 158, g = 181, b = 248}
    }
    local x_lightarmor_defaultcolors = {
        -- PANTS
        [0] = {r = 121, g = 209, b = 227},
        -- SHIRT
        [1] = {r = 255, g = 255, b = 255},
        -- GLOVES
        [2] = {r = 0, g = 122, b = 183},
        -- SHOES
        [3] = {r = 255, g = 39, b = 31},
        -- HAIR
        [4] = {r = 70, g = 70, b = 70},
        -- SKIN
        [5] = {r = 255, g = 255, b = 255},
        -- CAP
        [6] = {r = 228, g = 177, b = 53},
        -- EMBLEM
        [7] = {r = 158, g = 181, b = 248}
    }
    local colors = x_defaultcolors
    if (s.x_armor == 1) then
        colors = x_lightarmor_defaultcolors
    end
    if s.x_glow_index >= 2 and s.x_charge_timer >= 105 then
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = {r = s.colorR[i], g = s.colorG[i], b = s.colorB[i]}
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            color.r = color.r + 140
            if color.r > 255 then
                color.r = 255
            end
            if i == SKIN then
                color = {r = 255, g = 155, b = 155}
            end
            m.marioBodyState.shadeR = 215
            m.marioBodyState.lightR = 255
            m.marioBodyState.shadeG = 100
            m.marioBodyState.lightG = 100
            m.marioBodyState.shadeB = 100
            m.marioBodyState.lightB = 100
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    elseif s.x_glow_index >= 2 and s.x_charge_timer > 64 and s.x_charge_timer < 105 then
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = {r = s.colorR[i], g = s.colorG[i], b = s.colorB[i]}
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            color.g = color.g + 140
            if color.g > 255 then
                color.g = 255
            end
            if i == SKIN then
                color = {r = 155, g = 255, b = 155}
            end
            m.marioBodyState.shadeR = 100
            m.marioBodyState.lightR = 100
            m.marioBodyState.shadeG = 215
            m.marioBodyState.lightG = 255
            m.marioBodyState.shadeB = 100
            m.marioBodyState.lightB = 100
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    elseif s.x_glow_index >= 2 and s.x_charge_timer > 10 and s.x_charge_timer <= 64 then
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = {r = s.colorR[i], g = s.colorG[i], b = s.colorB[i]}
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            color.b = color.b + 140
            if color.b > 255 then
                color.b = 255
            end
            if i == SKIN then
                color = {r = 155, g = 155, b = 255}
            end
            m.marioBodyState.shadeR = 100
            m.marioBodyState.lightR = 100
            m.marioBodyState.shadeG = 100
            m.marioBodyState.lightG = 100
            m.marioBodyState.shadeB = 215
            m.marioBodyState.lightB = 255
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    else
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = {r = s.colorR[i], g = s.colorG[i], b = s.colorB[i]}
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            if i == SKIN then
                color = {r = 255, g = 255, b = 255}
            end
            m.marioBodyState.shadeR = 127
            m.marioBodyState.lightR = 255
            m.marioBodyState.shadeG = 127
            m.marioBodyState.lightG = 255
            m.marioBodyState.shadeB = 127
            m.marioBodyState.lightB = 255
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    end
end

---------------------------------------------------------------
--- LOOP ------------------------------------------------------
---------------------------------------------------------------


-- For the current player
function x_update_local(m)
    local s = gPlayerSyncTable[m.playerIndex]

    --- INTRO ----------------------------------------------
    mmx_update_local_intro_timer(m)

    --- CHARGING X-BUSTER ----------------------------------
    mmx_x_store_colors(m)
    s.x_glow_index = s.x_glow_index + 1
    
    if s.x_glow_index == 4 then
        s.x_glow_index = 0
    end

    -- Holding to charge, releasing to reset
    s.x_charge_level = 0
    if (m.controller.buttonDown & B_BUTTON) ~= 0 and s.menu_open == false then
        s.x_charge_timer = s.x_charge_timer + 1
    else
        s.x_charge_spawned = 0
        s.x_max_charge_looped = 0
        if s.x_charge_timer > 20 and s.x_charge_timer < 66 then
            s.x_shooting = X_SHOOT_DURATION + 1
            s.x_charge_level = 1
        elseif s.x_charge_timer >= 66 and s.x_charge_timer < 105 then
            s.x_shooting = X_SHOOT_DURATION + 1
            s.x_charge_level = 2
        elseif s.x_charge_timer >= 105 then
            s.x_shooting = X_SHOOT_DURATION + 1
            s.x_charge_level = 3
        end
        s.x_charge_timer = 0
    end

    --- AIR ------------------------------------------------
    mmx_local_update_air(m)

    --- LANDING --------------------------------------------
    mmx_local_update_landing(m)

    --- WALL JUMPING ---------------------------------------
    mmx_local_update_walljump(m)

    --- DASHING --------------------------------------------
    if s.ground_dash_cooldown > 0 then
        s.ground_dash_cooldown = s.ground_dash_cooldown - 1
    end

    --- AIR DASHING ----------------------------------------
    if ((m.action & ACT_FLAG_AIR) == 0 or m.action == ACT_BUTT_SLIDE_AIR) and m.action ~= ACT_DASH then
        
        s.jump_dash_state = false
        s.already_airdashed = false
        s.jumped_from_ground_dash = false
        
        -- If holding Z on ground without dashing and then jumping, jump_dash_state will be set
        -- needs to be tested though
        if (m.input & INPUT_Z_DOWN) ~= 0 then
            s.jump_dash_state = true
        end
    end

    --------------------------------------------------------
    --- SHOOTING -------------------------------------------
    --------------------------------------------------------

    if s.x_shooting > 0 then
        s.x_shooting = s.x_shooting - 1
    end
    if (m.input & INPUT_B_PRESSED) ~= 0 and s.x_shooting < X_SHOOT_IASA then
        s.x_shooting = X_SHOOT_DURATION
    end

end

local DEFAULTHANDS_TABLE = DEFAULTHANDS_TABLE

-- For all players
function x_update_all(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    local mGfx = m.marioObj.header.gfx
    local animFrame = mGfx.animInfo.animFrame

    if (s.enable_model) then
        if ((m.action & ACT_FLAG_SWIMMING_OR_FLYING) ~= 0 or DEFAULTHANDS_TABLE[m.action]) then
            if (s.x_armor == 0) then
                if _G.charSelectExists then
                    _G.charSelect.character_edit(x_charSelectPlacement, "[MMX] X", x_description, "ganewatch", {r = 39, g = 95, b = 216}, 
                    E_model_x_defaulthands, CT_MARIO, x_hud_icon)
                else
                    gPlayerSyncTable[m.playerIndex].modelId = E_model_x_defaulthands
                end
            elseif (s.x_armor == 1) then
                if _G.charSelectExists then
                    _G.charSelect.character_edit(x_lightarmor_charSelectPlacement, "[MMX] X - 1st Armor", x_lightarmor_description, "ganewatch", 
                    {r = 39, g = 95, b = 216}, E_model_x_lightarmor_defaulthands, CT_MARIO, x_lightarmor_hud_icon)
                else
                    gPlayerSyncTable[m.playerIndex].modelId = E_model_x_lightarmor_defaulthands
                end
            end
        else
            if (s.x_armor == 0) then
                if _G.charSelectExists then
                    _G.charSelect.character_edit(x_charSelectPlacement, "[MMX] X", x_description, "ganewatch", {r = 39, g = 95, b = 216}, 
                    E_model_x, CT_MARIO, x_hud_icon)
                else
                    gPlayerSyncTable[m.playerIndex].modelId = E_model_x
                end
            elseif (s.x_armor == 1) then
                if _G.charSelectExists then
                    _G.charSelect.character_edit(x_lightarmor_charSelectPlacement, "[MMX] X - 1st Armor", x_lightarmor_description, "ganewatch", {r = 39, g = 95, b = 216}, 
                    E_model_x_lightarmor, CT_MARIO, x_lightarmor_hud_icon)
                else
                    gPlayerSyncTable[m.playerIndex].modelId = E_model_x_lightarmor
                end
            end
        end
    end

    --------------------------------------------------------
    --- GENERAL --------------------------------------------
    --------------------------------------------------------

    mmx_update_props(m)

    --------------------------------------------------------
    --- IDLE -----------------------------------------------
    --------------------------------------------------------
    
    mmx_update_sleeping(m)
    mmx_update_idle(m, s.x_shooting)

    --------------------------------------------------------
    --- WATER JUMP -----------------------------------------
    --------------------------------------------------------
    
    mmx_update_water_jump(m)

    --------------------------------------------------------
    --- WALKING --------------------------------------------
    --------------------------------------------------------

    mmx_update_walking(m, s.x_shooting)

    --------------------------------------------------------
    --- JUMPING AND FALLING --------------------------------
    --------------------------------------------------------

    mmx_update_jump_fall(m, 32, 56, 49, s.x_shooting)

    --------------------------------------------------------
    --- CHARGING X-BUSTER ----------------------------------
    --------------------------------------------------------

    mmx_x_apply_colors(m)
    if (s.x_charge_timer == 9) then
        mmx.x_charge_sound_stopped = false
        mmx_play_sound(SOUND_X_CHARGE_BEGIN, m.pos, 0.6)
        --spawn_non_sync_object(id_bhvChargePre, E_model_charge_pre, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
        --    obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
        --end)
        if (s.x_charge_spawned < 1) then
            if (m.playerIndex == 0) then
                s.x_charge_spawned = 1
                spawn_charge(m, 1)
                network_send(true, { type = 'charge',
                    m = gNetworkPlayers[m.playerIndex].globalIndex, 
                    chargeLevel = 1
                })
            end
        end
    elseif (s.x_charge_timer == 67) then
        if (s.x_charge_spawned < 2) then
            if (m.playerIndex == 0) then
                s.x_charge_spawned = 2
                spawn_charge(m, 2)
                network_send(true, { type = 'charge',
                    m = gNetworkPlayers[m.playerIndex].globalIndex, 
                    chargeLevel = 2
                })
            end
        end
        mmx.x_charge_sound_stopped = false
        mmx_play_sound(SOUND_X_CHARGE_LOOP, m.pos, 0.6)
    elseif (s.x_charge_timer == 106) then
        mmx.x_charge_sound_stopped = false
        if (s.x_max_charge_looped == 0) then
            mmx_play_sound(SOUND_X_CHARGE_MAX_BEGIN, m.pos, 0.6)
        else
            mmx_play_sound(SOUND_X_CHARGE_MAX_LOOP, m.pos, 0.6)
        end
        if (s.x_charge_spawned < 3) then
            if (m.playerIndex == 0) then
                s.x_charge_spawned = 3
                spawn_charge(m, 3)
                network_send(true, { type = 'charge',
                    m = gNetworkPlayers[m.playerIndex].globalIndex, 
                    chargeLevel = 3
                })
            end
        end
    end

     -- Jump to the looping point
    if (s.x_armor == 0) then
        if (s.x_charge_timer == 89) then
            s.x_charge_timer = 66
        end 
    elseif (s.x_armor == 1) then
        if (s.x_charge_timer == 127 and s.x_max_charge_looped == 0) then
            s.x_max_charge_looped = 1
            s.x_charge_timer = 105
        elseif (s.x_charge_timer == 116 and (s.x_max_charge_looped == 1 or s.x_charge_spawned < 3)) then
            s.x_charge_timer = 105
        elseif (s.x_charge_timer == 90) then
            mmx_play_sound(SOUND_X_CHARGE_LOOP, m.pos, 0.6)
        end
    end

    if (s.x_charge_timer == 0) then
        if (mmx.x_charge_sound_stopped == false) then
            audio_sample_stop(SOUND_X_CHARGE_BEGIN)
            audio_sample_stop(SOUND_X_CHARGE_LOOP)
            audio_sample_stop(SOUND_X_CHARGE_MAX_BEGIN)
            audio_sample_stop(SOUND_X_CHARGE_MAX_LOOP)
            mmx.x_charge_sound_stopped = true
        end
    end

    --------------------------------------------------------
    --- DASHING --------------------------------------------
    --------------------------------------------------------
    if ((m.input & INPUT_Z_PRESSED) ~= 0)
    and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) 
    and s.ground_dash_cooldown == 0
        then
        m.faceAngle.y = m.intendedYaw
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_DASH, 1)
    end

    --------------------------------------------------------
    --- AIR DASHING ----------------------------------------
    --------------------------------------------------------
    if (m.input & INPUT_Z_PRESSED) ~= 0 and (m.action ~= ACT_BUBBLED) and ((m.action == ACT_JUMP_CUSTOM 
    or m.action == ACT_FREEFALL_CUSTOM 
    or m.action == ACT_WATER_JUMP)) and s.x_armor == 0
    and s.jump_dash_state == false and s.already_airdashed == false then
        m.vel.y = 0
        m.faceAngle.y = m.intendedYaw
        set_mario_action(m, ACT_AIR_DASH, 1)
    end

    -- Trail spawning
    if (s.jump_dash_state == true) then
        if (m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_JUMP_CUSTOM 
        or m.action == ACT_WALL_KICK_CUSTOM or m.action == ACT_WATER_JUMP) then
            spawn_non_sync_object(id_bhvTrail, E_model_x_alpha_jump, mGfx.pos.x , mGfx.pos.y , mGfx.pos.z , function (obj)
                obj.oMoveAngleYaw = m.faceAngle.y
            end)
        end
    elseif (s.already_airdashed == true) then
        if (m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_JUMP_CUSTOM) then
            spawn_non_sync_object(id_bhvTrail, E_model_x_alpha_jump, mGfx.pos.x , mGfx.pos.y , mGfx.pos.z , function (obj)
                obj.oMoveAngleYaw = m.faceAngle.y
            end)
        end
    end

    --------------------------------------------------------
    --- LANDING --------------------------------------------
    --------------------------------------------------------

    mmx_update_landing(m, s.x_shooting)

    --------------------------------------------------------
    --- BRAKE STOP -----------------------------------------
    --------------------------------------------------------

    mmx_update_brake_stop(m)

    --------------------------------------------------------
    --- STOP CROUCH ----------------------------------------
    --------------------------------------------------------

    mmx_update_stop_crouch(m)

    --------------------------------------------------------
    --- BUTT SLIDE -----------------------------------------
    --------------------------------------------------------

    mmx_update_butt_slide(m)

    --------------------------------------------------------
    --SHOOTING----------------------------------------------
    --------------------------------------------------------
    if s.x_shooting > 0 then
        if (m.action == ACT_BRAKING or m.action == ACT_BRAKING_STOP) then
            set_mario_action(m, ACT_IDLE, 0)
        end
        if (m.action == ACT_JUMP_CUSTOM 
        or m.action == ACT_FREEFALL_CUSTOM 
        or m.action == ACT_STEEP_JUMP 
        or m.action == ACT_WATER_JUMP
        or m.action == ACT_WALL_KICK_AIR
        or m.action == ACT_TOP_OF_POLE_JUMP) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_jump_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    spawn_shot(m, 75, 60, -5000, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 70, 
                        armLength = 60, 
                        armTheta = -5000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_DASH) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_OPEN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_dash_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                set_anim_to_frame(m, 3)
                if (m.playerIndex == 0) then
                    spawn_shot(m, 30, 170, 1700, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 30, 
                        armLength = 170, 
                        armTheta = 1700,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_AIR_DASH) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_OPEN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_dash_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                set_anim_to_frame(m, 3)
                if (m.playerIndex == 0) then
                    spawn_shot(m, 55, 170, 1700, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 55, 
                        armLength = 170, 
                        armTheta = 1700,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_WALL_SLIDE or m.action == ACT_AIR_HIT_WALL_CUSTOM) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_OPEN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_wall_slide_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    spawn_shot(m, 70, 85, 3000, s.x_charge_level)                     
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 70, 
                        armLength = 85, 
                        armTheta = 3000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_WALL_KICK_CUSTOM) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_jump_shoot")
            --m.marioObj.header.gfx.animInfo.animFrame = 12 - s.x_shooting
            if s.x_shooting == X_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    spawn_shot(m, 75, 60, -5000, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 75, 
                        armLength = 60, 
                        armTheta = -5000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_WALKING_CUSTOM or m.action == ACT_DECELERATING or m.action == ACT_WALKING) then
            mGfx.angle.x = 0
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_running_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    spawn_shot(m, 75, 90, -2000, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 75, 
                        armLength = 90, 
                        armTheta = -2000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_TURNING_AROUND) then
            smlua_anim_util_set_animation(m.marioObj, "x_turnaround_shoot")
            set_anim_to_frame(m, 1)
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            if s.x_shooting == X_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    spawn_shot(m, 75, 90, -2000, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 75, 
                        armLength = 90, 
                        armTheta = -2000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_IDLE or m.action == ACT_PANTING) then
            set_character_animation(m, CHAR_ANIM_IDLE_HEAD_CENTER)
            set_anim_to_frame(m, 12 - s.x_shooting)
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_idle_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                set_anim_to_frame(m, 1)
                if (m.playerIndex == 0) then
                    spawn_shot(m, 75, 90, -2000, s.x_charge_level)
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 75, 
                        armLength = 90, 
                        armTheta = -2000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_FREEFALL_LAND or m.action == ACT_FREEFALL_LAND_STOP) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "x_land_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    spawn_shot(m, 75, 90, -2000, s.x_charge_level)                  
                    network_send(true, { type = 'shot',
                        m = gNetworkPlayers[m.playerIndex].globalIndex, 
                        armHeight = 75, 
                        armLength = 90, 
                        armTheta = -2000,
                        chargeLevel = s.x_charge_level
                    })
                    s.x_charge_level = 0
                end
            end
        end
    end

    --------------------------------------------------------
    --PUNCHING----------------------------------------------
    --------------------------------------------------------

    mmx_update_punching(m, s.x_shooting)

    --------------------------------------------------------
    --GROUND POUND------------------------------------------
    --------------------------------------------------------

    mmx_update_groundpound(m)

    --------------------------------------------------------
    --GROUND TURNAROUND-------------------------------------
    --------------------------------------------------------
    
    mmx_update_turnaround(m, s.x_shooting)
end