-- name: \\#0D3CC0\\Mega Man X v1.1.4\\#FFFFFF\\
-- description: Mega Man X v1.1.4

-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local set_mario_y_vel_based_on_fspeed, mmx_play_sound, set_mario_action, vile_meter_render, render_hud_mario_lives,
mmx_play_sound = 
set_mario_y_vel_based_on_fspeed, mmx_play_sound, set_mario_action, vile_meter_render, render_hud_mario_lives,
mmx_play_sound

x_hud_icon = get_texture_info("mmx_x_hud")
x_lightarmor_hud_icon = get_texture_info("mmx_x_lightarmor_hud")
vile_hud_icon = get_texture_info("mmx_vile_hud")
x_description = 'Default X moveset with 2 charge levels and an air dash (X7/X8 inspired).'
x_lightarmor_description = 'First Armor moveset with 3 charge levels and no air dash.'
vile_description = 'Maverick Hunter X inspired moveset, with three different attacks mapped to X, Y, Z. No air dash.'

-- Character Select Support
if _G.charSelectExists then
    x_charSelectPlacement = _G.charSelect.character_add("[MMX] X", 
    x_description, "ganewatch", {r = 39, g = 95, b = 216}, E_model_x, CT_MARIO, x_hud_icon)
    x_lightarmor_charSelectPlacement = _G.charSelect.character_add("[MMX] X - 1st Armor", x_lightarmor_description, "ganewatch",
     {r = 39, g = 95, b = 216}, E_model_x_lightarmor, CT_MARIO, x_lightarmor_hud_icon)
    vile_charSelectPlacement = _G.charSelect.character_add("[MMX] Vile", vile_description, 
    "ganewatch", {r = 39, g = 95, b = 216}, E_model_vile, CT_MARIO, vile_hud_icon)
    -- Handle Voicelines via Character Select
    _G.charSelect.character_add_voice(E_model_x, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_x_defaulthands, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_x_lightarmor, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_x_lightarmor_defaulthands, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile_defaulthands, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile_knee, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile_cannon, VILE_CUSTOM_VOICETABLE)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == X_CUSTOM_VOICETABLE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == X_CUSTOM_VOICETABLE then return _G.charSelect.voice.snore(m) end
    end)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VILE_CUSTOM_VOICETABLE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VILE_CUSTOM_VOICETABLE then return _G.charSelect.voice.snore(m) end
    end)
end

local function character_select_update()
    local s = gPlayerSyncTable[0]
    if x_charSelectPlacement == _G.charSelect.character_get_current_number() then
        s.character = 'x'
        s.x_armor = 0
    elseif x_lightarmor_charSelectPlacement == _G.charSelect.character_get_current_number() then
        s.character = 'x'
        s.x_armor = 1
    elseif vile_charSelectPlacement == _G.charSelect.character_get_current_number() then
        s.character = 'vile'
    else
        s.character = 'none'
    end
end

function mario_update(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]

    if _G.charSelectExists then
        character_select_update()
    end

    if (s.character == 'x') then
        if m.playerIndex == 0 then
            x_update_local(m)
        end
        if active_player(m) then
            x_update_all(m)
        end
    elseif (s.character == 'vile') then
        if m.playerIndex == 0 then
            vile_update_local(m)
        end
        if active_player(m) then
            vile_update_all(m)
        end
    end

    if (s.character ~= 'none') then
        mmx.dPrevPos = {
            x = m.pos.x - mmx.prevPos.x,
            y = m.pos.y - mmx.prevPos.y,
            z = m.pos.z - mmx.prevPos.z
        }
        mmx.prevPos = { x = m.pos.x, y = m.pos.y, z = m.pos.z}

        -- This momentarily swaps to the vanilla walking action upon interacting with doors
        -- Because the code that handles door interaction is hardwired to ACT_WALKING
        if (m.marioObj.collidedObjInteractTypes & (INTERACT_WARP_DOOR | INTERACT_DOOR | INTERACT_KOOPA_SHELL) ~= 0 
        and m.action == ACT_WALKING_CUSTOM) then
            if (m.playerIndex == 0) then
                s.execute_walking = true
            end
            set_mario_action(m, ACT_WALKING, 0)
        elseif m.action == ACT_WALKING then
            if (m.playerIndex == 0) then
                s.execute_walking = false
            end
            set_mario_action(m, ACT_WALKING, 0)
        end
    else
        network_player_reset_override_palette(gNetworkPlayers[m.playerIndex])
    end
end

-------------------------------------
---- Before set action functions ----
-------------------------------------

-- ACT_DIVE
function before_act_dive(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    if (m.action & ACT_FLAG_AIR) == 0 then
        if (mmx.execute_punch) then
            return ACT_MOVE_PUNCHING
        end
    end
    mmx.smoothContinuityFlag = true
    return 1
end

-- ACT_CROUCH_SLIDE
function before_act_crouch_slide(m, incomingAct)
    if (m.playerIndex == 0) then
        m.marioObj.header.gfx.pos.y = m.pos.y
    end
    return 1
end

-- ACT_FREEFALL_LAND_STOP
-- ACT_FREEFALL_LAND
-- ACT_JUMP_LAND
function before_general_act_land(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.playerIndex == 0) then
        if s.character == 'x' then
            mmx_play_sound(SOUND_X_LAND, m.pos, 0.6)
        elseif s.character == 'vile' then
            mmx_play_sound(SOUND_VILE_STEP, m.pos, 0.35)
        end
    end
    return ACT_FREEFALL_LAND_STOP
end

-- ACT_JUMP_KICK
-- ACT_LEDGE_GRAB
-- ACT_LEDGE_CLIMB_DOWN
-- ACT_LEDGE_CLIMB_FAST
function before_several_act_unused_smooth(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    mmx.smoothContinuityFlag = true
    if (m.action == ACT_HOLD_JUMP or m.action == ACT_HOLD_FREEFALL) then
        return ACT_FREEFALL_CUSTOM
    end
    return 1
end 

-- ACT_WALKING
-- ACT_FINISH_TURNING_AROUND
function before_act_walking(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if (incomingAct == ACT_WALKING) then
        if (s.execute_walking) then
            return incomingAct
        end
        local floorClass = mario_get_floor_class(m)
        if (floorClass ~= SURFACE_CLASS_VERY_SLIPPERY) then
            local mag = math.min(m.intendedMag, 8)
            if (0.0 <= m.forwardVel and m.forwardVel < mag) then
                m.forwardVel = mag
            end
        end
        m.marioObj.oMarioWalkingPitch = 0
    end
    return ACT_WALKING_CUSTOM
end

-- ACT_MOVE_PUNCHING
function before_act_move_punching(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (mmx.execute_punch) then
        return incomingAct
    end
    mmx.smoothContinuityFlag = true
    return 1
end

-- ACT_PUNCHING
function before_act_punching(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (mmx.execute_punch) then
        return incomingAct
    end
    -- Just this line is enough, we don't need to smooth the continuity because the character is stationary
    m.marioObj.header.gfx.pos.y = m.pos.y
    return 1
end

-- ACT_FREEFALL
function before_act_freefall(m, incomingAct)
    --local mmx = gMmxStates[m.playerIndex]
    --mmx.smoothContinuityFlag = true  
    return ACT_FREEFALL_CUSTOM
end

-- ACT_JUMP
-- ACT_STEEP_JUMP
-- ACT_DOUBLE_JUMP
-- ACT_BACKFLIP
-- ACT_SIDE_FLIP
function before_act_general_jump(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    -- Offset the jump so the player model doesn't slightly clip into the ground right after jumps
    m.pos.y = m.pos.y + MODEL_Y_OFFSET
    -- This code was found in the set_mario_action for ACT_JUMP
    m.marioObj.header.gfx.animInfo.animID = -1;
    set_mario_y_vel_based_on_fspeed(m, 43.0, 0.25);
    m.forwardVel = m.forwardVel * 0.8;
    if (s.character == 'x') then
        mmx_play_sound(SOUND_X_JUMP, m.pos, 0.3)
    elseif (s.character == 'vile') then
        mmx_play_sound(SOUND_VILE_JUMP, m.pos, 0.4)
    end
    return ACT_JUMP_CUSTOM
end

-- ACT_WATER_JUMP
function before_act_water_jump(m, incomingAct)
    if (m.playerIndex == 0) then
        set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
    end
    return incomingAct
end

-- ACT_WALL_KICK_AIR
-- ACT_TOP_OF_POLE_JUMP
function before_act_pole_jump(m, incomingAct)
    -- Offset the jump so the player model doesn't slightly clip into the ground right after jumps
    m.pos.y = m.pos.y + MODEL_Y_OFFSET
    -- This code was found in the set_mario_action for ACT_JUMP
    m.marioObj.header.gfx.animInfo.animID = -1;
    set_mario_y_vel_based_on_fspeed(m, 65.0, 0.25);
    m.forwardVel = m.forwardVel * 0.8;
    return ACT_JUMP_CUSTOM
end

-- ACT_IDLE
function before_act_idle(m, incomingAct)
    set_anim_to_frame(m, 1)
    return incomingAct
end

-- ACT_AIR_HIT_WALL
function before_act_air_hit_wall(m, incomingAct)
    return ACT_AIR_HIT_WALL_CUSTOM
end

local convert_actions = {
    [ACT_WALKING] = before_act_walking,
    [ACT_DIVE] = before_act_dive,
    [ACT_CROUCH_SLIDE] = before_act_crouch_slide,
    [ACT_FREEFALL_LAND_STOP] = before_general_act_land,
    [ACT_FREEFALL_LAND] = before_general_act_land,
    [ACT_JUMP_LAND] = before_general_act_land,
    [ACT_JUMP_KICK] = before_several_act_unused_smooth,
    [ACT_LEDGE_GRAB] = before_several_act_unused_smooth,
    [ACT_LEDGE_CLIMB_DOWN] = before_several_act_unused_smooth,
    [ACT_LEDGE_CLIMB_FAST] = before_several_act_unused_smooth,
    [ACT_FINISH_TURNING_AROUND] = before_act_walking,
    [ACT_MOVE_PUNCHING] = before_act_move_punching,
    [ACT_PUNCHING] = before_act_punching,
    [ACT_FREEFALL] = before_act_freefall,
    [ACT_JUMP] = before_act_general_jump,
    [ACT_WALL_KICK_AIR] = before_act_pole_jump,
    [ACT_TOP_OF_POLE_JUMP] = before_act_pole_jump,
    [ACT_STEEP_JUMP] = before_act_general_jump,
    [ACT_DOUBLE_JUMP] = before_act_general_jump,
    [ACT_BACKFLIP] = before_act_general_jump,
    [ACT_SIDE_FLIP] = before_act_general_jump,
    [ACT_WATER_JUMP] = before_act_water_jump,
    [ACT_IDLE] = before_act_idle,
    [ACT_AIR_HIT_WALL] = before_act_air_hit_wall
}

local before_set_mario_action = function(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if active_player(m) and s.character ~= 'none' then
        if convert_actions[incomingAct] then
            return convert_actions[incomingAct](m, incomingAct)
        end
        return incomingAct
    end
end

local on_receive_spawn_data = function(table)
    local np = network_player_from_global_index(table.m)
    local m = gMarioStates[np.localIndex]
    if (active_player(m)) then
        if (table.type == 'shot') then
            local armHeight = table.armHeight
            local armLength = table.armLength
            local armTheta = table.armTheta
            local chargeLevel = table.chargeLevel
            spawn_shot(m, armHeight, armLength, armTheta, chargeLevel)
        elseif (table.type == 'napalm') then
            spawn_napalm(m, table.grounded)
        elseif (table.type == 'charge') then
            spawn_charge(m, table.chargeLevel)
        end
    end
end

hook_event(HOOK_ON_PACKET_RECEIVE, on_receive_spawn_data)

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_BEFORE_SET_MARIO_ACTION, before_set_mario_action)


hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_HUD)
    djui_hud_set_color(255, 255, 255, 255)
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action ~= ACT_END_PEACH_CUTSCENE and m.action ~= ACT_END_WAVING_CUTSCENE and (m.action ~= ACT_INTRO_CUTSCENE or introTimer >= 1195)) then
        if (s.character == 'vile') then
            vile_meter_render()
        end
        if (s.character ~= 'none') then
            render_hud_mario_lives()
        else    
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) | HUD_DISPLAY_FLAG_LIVES)
        end
    end
end)